import { ArithmeticError, Exponent } from "./common";
export declare type DivideExponents<L extends Exponent, R extends Exponent> = L extends -5 ? DividedByNegative5<R> : L extends -4 ? DividedByNegative4<R> : L extends -3 ? DividedByNegative3<R> : L extends -2 ? DividedByNegative2<R> : L extends -1 ? DividedByNegative1<R> : L extends 0 ? (R extends 0 ? ArithmeticError : 0) : L extends 1 ? DividedByPositive1<R> : L extends 2 ? DividedByPositive2<R> : L extends 3 ? DividedByPositive3<R> : L extends 4 ? DividedByPositive4<R> : L extends 5 ? DividedByPositive5<R> : ArithmeticError;
export declare type DividedByNegative5<N extends Exponent> = N extends -5 ? 1 : N extends -1 ? 5 : N extends 1 ? -5 : N extends 5 ? -1 : ArithmeticError;
export declare type DividedByNegative4<N extends Exponent> = N extends -4 ? 1 : N extends -2 ? 2 : N extends -1 ? 4 : N extends 1 ? -4 : N extends 2 ? -2 : N extends 4 ? -1 : ArithmeticError;
export declare type DividedByNegative3<N extends Exponent> = N extends -3 ? 1 : N extends -1 ? 3 : N extends 1 ? -3 : N extends 3 ? -1 : ArithmeticError;
export declare type DividedByNegative2<N extends Exponent> = N extends -2 ? 1 : N extends -1 ? 2 : N extends 1 ? -2 : N extends 2 ? -1 : ArithmeticError;
export declare type DividedByNegative1<N extends Exponent> = N extends -1 ? 1 : N extends 1 ? -1 : ArithmeticError;
export declare type DividedByPositive1<N extends Exponent> = N extends -1 ? -1 : N extends 1 ? 1 : ArithmeticError;
export declare type DividedByPositive2<N extends Exponent> = N extends -2 ? -1 : N extends -1 ? -2 : N extends 1 ? 2 : N extends 2 ? 1 : ArithmeticError;
export declare type DividedByPositive3<N extends Exponent> = N extends -3 ? -1 : N extends -1 ? -3 : N extends 1 ? 3 : N extends 3 ? 1 : ArithmeticError;
export declare type DividedByPositive4<N extends Exponent> = N extends -4 ? -1 : N extends -2 ? -2 : N extends -1 ? -4 : N extends 1 ? 4 : N extends 2 ? 2 : N extends 4 ? 1 : ArithmeticError;
export declare type DividedByPositive5<N extends Exponent> = N extends -5 ? -1 : N extends -1 ? -5 : N extends 1 ? 5 : N extends 5 ? 1 : ArithmeticError;
