import { Exponent } from "../exponent";
import { Length, PlaneAngle } from "../quantity/quantities";
import { Measure } from "./measure";
import { DivideUnits, ExponentiateUnit, MultiplyUnits, NthRootableUnit, NthRootUnit, Unit } from "./types";
export declare const abs: <U extends Partial<{
    [dimension: string]: [string, Exponent];
}>>(x: Measure<U>) => Measure<U>;
export declare const acos: (angle: Measure<{}>) => Measure<{
    planeAngle: [string, 1];
}>;
export declare const asin: (angle: Measure<{}>) => Measure<{
    planeAngle: [string, 1];
}>;
export declare const atan: (angle: Measure<{}>) => Measure<{
    planeAngle: [string, 1];
}>;
export declare const ceil: <U extends Partial<{
    [dimension: string]: [string, Exponent];
}>>(x: Measure<U>) => Measure<U>;
export declare const cos: (angle: Measure<{
    planeAngle: [string, 1];
}>) => Measure<{}>;
export declare const floor: <U extends Partial<{
    [dimension: string]: [string, Exponent];
}>>(x: Measure<U>) => Measure<U>;
export declare const fround: <U extends Partial<{
    [dimension: string]: [string, Exponent];
}>>(x: Measure<U>) => Measure<U>;
export declare const hypot: <U extends Partial<{
    [dimension: string]: [string, Exponent];
}>>(first: Measure<U>, ...rest: Measure<U>[]) => Measure<U>;
export declare const max: <U extends Partial<{
    [dimension: string]: [string, Exponent];
}>>(first: Measure<U>, ...rest: Measure<U>[]) => Measure<U>;
export declare const min: <U extends Partial<{
    [dimension: string]: [string, Exponent];
}>>(first: Measure<U>, ...rest: Measure<U>[]) => Measure<U>;
export declare const round: <U extends Partial<{
    [dimension: string]: [string, Exponent];
}>>(x: Measure<U>) => Measure<U>;
export declare const sin: (angle: Measure<{
    planeAngle: [string, 1];
}>) => Measure<{}>;
export declare const tan: (angle: Measure<{
    planeAngle: [string, 1];
}>) => Measure<{}>;
export declare const trunc: <U extends Partial<{
    [dimension: string]: [string, Exponent];
}>>(x: Measure<U>) => Measure<U>;
export declare function atan2(y: Length, x: Length): PlaneAngle;
export declare function pow<U extends Unit, Y extends Exponent>(x: Measure<U>, y: Y): Measure<ExponentiateUnit<U, Y>>;
export declare function sqrt<U extends NthRootableUnit<2>>(x: Measure<U>): Measure<NthRootUnit<U, 2>>;
export declare function cbrt<U extends NthRootableUnit<3>>(x: Measure<U>): Measure<NthRootUnit<U, 3>>;
export declare function add<U extends Unit>(left: Measure<U>, right: Measure<U>): Measure<U>;
export declare function subtract<U extends Unit>(left: Measure<U>, right: Measure<U>): Measure<U>;
export declare function multiply<L extends Unit, R extends Unit>(left: Measure<L>, right: Measure<R>): Measure<MultiplyUnits<L, R>>;
export declare function divide<L extends Unit, R extends Unit>(left: Measure<L>, right: Measure<R>): Measure<DivideUnits<L, R>>;
export declare function sum<U extends Unit>(first: Measure<U>, ...rest: Array<Measure<U>>): Measure<U>;
