import { Exponent } from "../exponent";
import { DivideUnits, ExponentiateUnit, MultiplyUnits, NthRootableUnit, NthRootUnit, Unit } from "./types";
export declare function dimension<D extends string>(dim: D, symbol?: string): {
    [K in D]: [string, 1];
};
export declare function multiplyUnits<L extends Unit, R extends Unit>(left: L, right: R): MultiplyUnits<L, R>;
export declare function divideUnits<L extends Unit, R extends Unit>(left: L, right: R): DivideUnits<L, R>;
export declare function exponentiateUnit<U extends Unit, N extends Exponent>(unit: U, power: N): ExponentiateUnit<U, N>;
export declare function nthRootUnit<U extends NthRootableUnit<N>, N extends Exponent>(unit: U, root: N): NthRootUnit<U, N>;
